diff -uNr --exclude-from=excludes --exclude CVS binutils-2.14.orig/ld/scripttempl/elfm68hc11.sc binutils-2.14/ld/scripttempl/elfm68hc11.sc
--- binutils-2.14.orig/ld/scripttempl/elfm68hc11.sc	2002-10-13 11:29:35.000000000 +0200
+++ binutils-2.14/ld/scripttempl/elfm68hc11.sc	2003-09-10 08:30:17.000000000 +0200
@@ -28,15 +28,7 @@
   {
     ${CONSTRUCTING+ PROVIDE (__CTOR_LIST__ = .); }
     ${CONSTRUCTING+${CTOR_START}}
-    *(.ctors)
-    /* We don't want to include the .ctor section from
-       from the crtend.o file until after the sorted ctors.
-       The .ctor section from the crtend file contains the
-       end of ctors marker and it must be last
-
-    KEEP (*(EXCLUDE_FILE (*crtend.o) .ctors))
-    KEEP (*(SORT(.ctors.*)))
-    KEEP (*(.ctors)) */
+    KEEP (*(.ctors))
 
     ${CONSTRUCTING+${CTOR_END}}
     ${CONSTRUCTING+ PROVIDE(__CTOR_END__ = .); }
@@ -45,12 +37,7 @@
 DTOR="  .dtors	${CONSTRUCTING-0} :
   {
     ${CONSTRUCTING+ PROVIDE(__DTOR_LIST__ = .); }
-    *(.dtors)
-    /*
-    KEEP (*crtbegin.o(.dtors))
-    KEEP (*(EXCLUDE_FILE (*crtend.o) .dtors))
-    KEEP (*(SORT(.dtors.*)))
-    KEEP (*(.dtors)) */
+    KEEP (*(.dtors))
     ${CONSTRUCTING+ PROVIDE(__DTOR_END__ = .); }
   } ${RELOCATING+ > ${TEXT_MEMORY}}"
 
@@ -326,6 +313,8 @@
     /* .gnu.warning sections are handled specially by elf32.em.  */
     *(.gnu.warning)
     ${RELOCATING+*(.gnu.linkonce.t.*)}
+    ${RELOCATING+*(.tramp)}
+    ${RELOCATING+*(.tramp.*)}
 
     ${RELOCATING+${FINISH_CODE}}
 
@@ -339,6 +328,11 @@
     KEEP (*(.eh_frame))
   } ${RELOCATING+ > ${TEXT_MEMORY}}
 
+  .gcc_except_table ${RELOCATING-0} :
+  {
+    *(.gcc_except_table)
+  } ${RELOCATING+ > ${TEXT_MEMORY}}
+
   .rodata  ${RELOCATING-0} :
   {
     *(.rodata)
diff -uNr --exclude-from=excludes --exclude CVS binutils-2.14.orig/ld/scripttempl/elfm68hc12.sc binutils-2.14/ld/scripttempl/elfm68hc12.sc
--- binutils-2.14.orig/ld/scripttempl/elfm68hc12.sc	2002-10-13 11:29:35.000000000 +0200
+++ binutils-2.14/ld/scripttempl/elfm68hc12.sc	2003-09-10 08:30:17.000000000 +0200
@@ -28,15 +28,7 @@
   {
     ${CONSTRUCTING+ PROVIDE (__CTOR_LIST__ = .); }
     ${CONSTRUCTING+${CTOR_START}}
-    *(.ctors)
-    /* We don't want to include the .ctor section from
-       from the crtend.o file until after the sorted ctors.
-       The .ctor section from the crtend file contains the
-       end of ctors marker and it must be last
-
-    KEEP (*(EXCLUDE_FILE (*crtend.o) .ctors))
-    KEEP (*(SORT(.ctors.*)))
-    KEEP (*(.ctors)) */
+    KEEP (*(.ctors))
 
     ${CONSTRUCTING+${CTOR_END}}
     ${CONSTRUCTING+ PROVIDE(__CTOR_END__ = .); }
@@ -45,12 +37,7 @@
 DTOR="  .dtors	${CONSTRUCTING-0} :
   {
     ${CONSTRUCTING+ PROVIDE(__DTOR_LIST__ = .); }
-    *(.dtors)
-    /*
-    KEEP (*crtbegin.o(.dtors))
-    KEEP (*(EXCLUDE_FILE (*crtend.o) .dtors))
-    KEEP (*(SORT(.dtors.*)))
-    KEEP (*(.dtors)) */
+    KEEP (*(.dtors))
     ${CONSTRUCTING+ PROVIDE(__DTOR_END__ = .); }
   } ${RELOCATING+ > ${TEXT_MEMORY}}"
 
@@ -324,6 +311,8 @@
     /* .gnu.warning sections are handled specially by elf32.em.  */
     *(.gnu.warning)
     ${RELOCATING+*(.gnu.linkonce.t.*)}
+    ${RELOCATING+*(.tramp)}
+    ${RELOCATING+*(.tramp.*)}
 
     ${RELOCATING+${FINISH_CODE}}
 
@@ -337,6 +326,11 @@
     KEEP (*(.eh_frame))
   } ${RELOCATING+ > ${TEXT_MEMORY}}
 
+  .gcc_except_table ${RELOCATING-0} :
+  {
+    *(.gcc_except_table)
+  } ${RELOCATING+ > ${TEXT_MEMORY}}
+
   .rodata  ${RELOCATING-0} :
   {
     *(.rodata)
diff -uNr --exclude-from=excludes --exclude CVS binutils-2.14.orig/ld/testsuite/ChangeLog binutils-2.14/ld/testsuite/ChangeLog
--- binutils-2.14.orig/ld/testsuite/ChangeLog	2003-06-12 16:25:54.000000000 +0200
+++ binutils-2.14/ld/testsuite/ChangeLog	2003-09-10 08:30:17.000000000 +0200
@@ -1,3 +1,13 @@
+2003-07-23  Stephane Carrez  <stcarrez@nerim.fr>
+
+	* ld-srec/srec.exp: For m6811/m6812 use --defsym to define _.z soft
+	register.
+
+2003-06-18  Hans-Peter Nilsson  <hp@axis.com>
+
+	* ld-cris/locref1.d, ld-cris/locref1.s, ld-cris/locref2.d,
+	ld-cris/locref2.s: New tests.
+
 2003-06-10  Thiemo Seufer <seufer@csv.ica.uni-stuttgart.de>
 
 	* ld-mips-elf/rel32-n32.d: Force big endian assembly.
diff -uNr --exclude-from=excludes --exclude CVS binutils-2.14.orig/ld/testsuite/ld-srec/srec.exp binutils-2.14/ld/testsuite/ld-srec/srec.exp
--- binutils-2.14.orig/ld/testsuite/ld-srec/srec.exp	2003-04-01 17:50:31.000000000 +0200
+++ binutils-2.14/ld/testsuite/ld-srec/srec.exp	2003-09-10 08:30:18.000000000 +0200
@@ -281,7 +281,7 @@
     if {[istarget m6811-*-*] || [istarget m6812-*-*]} {
 	set flags "$flags --defsym _.frame=0 --defsym _.d1=0 --defsym _.d2=0"
 	set flags "$flags --defsym _.d3=0 --defsym _.d4=0"
-	set flags "$flags --defsym _.tmp=0 --defsym _.xy=0"
+	set flags "$flags --defsym _.tmp=0 --defsym _.xy=0 --defsym _.z=0"
     }
 
     # V850 targets need libgcc.a
diff -uNr --exclude-from=excludes --exclude CVS binutils-2.14.orig/opcodes/ChangeLog binutils-2.14/opcodes/ChangeLog
--- binutils-2.14.orig/opcodes/ChangeLog	2003-06-02 22:35:17.000000000 +0200
+++ binutils-2.14/opcodes/ChangeLog	2003-09-10 08:26:04.000000000 +0200
@@ -1,3 +1,8 @@
+2003-07-12  Richard Sandiford  <rsandifo@redhat.com>
+
+	* h8300-dis.c (bfd_h8_disassemble): Mask off the high bit of rs and rd
+	for INC and DEC operands.
+
 2003-05-16  Nick Clifton  <nickc@redhat.com>
 
 	* configure.in (ALL_LINGUAS): Add Romanian translation.
